/**
 * This code was GENERATED using the solita package.
 * Please DO NOT EDIT THIS FILE, instead rerun solita to update it or write a wrapper to add functionality.
 *
 * See: https://github.com/metaplex-foundation/solita
 */

import * as definedTypes from '../types';
import * as web3 from '@solana/web3.js';
import * as beet from '@metaplex-foundation/beet';
import * as beetSolana from '@metaplex-foundation/beet-solana';

/**
 * Arguments used to create {@link Edition}
 * @category Accounts
 * @category generated
 */
export type EditionArgs = {
  key: definedTypes.Key;
  parent: web3.PublicKey;
  edition: beet.bignum;
};
/**
 * Holds the data for the {@link Edition} Account and provides de/serialization
 * functionality for that data
 *
 * @category Accounts
 * @category generated
 */
export class Edition implements EditionArgs {
  private constructor(
    readonly key: definedTypes.Key,
    readonly parent: web3.PublicKey,
    readonly edition: beet.bignum,
  ) {}

  /**
   * Creates a {@link Edition} instance from the provided args.
   */
  static fromArgs(args: EditionArgs) {
    return new Edition(args.key, args.parent, args.edition);
  }

  /**
   * Deserializes the {@link Edition} from the data of the provided {@link web3.AccountInfo}.
   * @returns a tuple of the account data and the offset up to which the buffer was read to obtain it.
   */
  static fromAccountInfo(accountInfo: web3.AccountInfo<Buffer>, offset = 0): [Edition, number] {
    return Edition.deserialize(accountInfo.data, offset);
  }

  /**
   * Retrieves the account info from the provided address and deserializes
   * the {@link Edition} from its data.
   *
   * @throws Error if no account info is found at the address or if deserialization fails
   */
  static async fromAccountAddress(
    connection: web3.Connection,
    address: web3.PublicKey,
  ): Promise<Edition> {
    const accountInfo = await connection.getAccountInfo(address);
    if (accountInfo == null) {
      throw new Error(`Unable to find Edition account at ${address}`);
    }
    return Edition.fromAccountInfo(accountInfo, 0)[0];
  }

  /**
   * Deserializes the {@link Edition} from the provided data Buffer.
   * @returns a tuple of the account data and the offset up to which the buffer was read to obtain it.
   */
  static deserialize(buf: Buffer, offset = 0): [Edition, number] {
    return editionBeet.deserialize(buf, offset);
  }

  /**
   * Serializes the {@link Edition} into a Buffer.
   * @returns a tuple of the created Buffer and the offset up to which the buffer was written to store it.
   */
  serialize(): [Buffer, number] {
    return editionBeet.serialize(this);
  }

  /**
   * Returns the byteSize of a {@link Buffer} holding the serialized data of
   * {@link Edition}
   */
  static get byteSize() {
    return editionBeet.byteSize;
  }

  /**
   * Fetches the minimum balance needed to exempt an account holding
   * {@link Edition} data from rent
   *
   * @param connection used to retrieve the rent exemption information
   */
  static async getMinimumBalanceForRentExemption(
    connection: web3.Connection,
    commitment?: web3.Commitment,
  ): Promise<number> {
    return connection.getMinimumBalanceForRentExemption(Edition.byteSize, commitment);
  }

  /**
   * Determines if the provided {@link Buffer} has the correct byte size to
   * hold {@link Edition} data.
   */
  static hasCorrectByteSize(buf: Buffer, offset = 0) {
    return buf.byteLength - offset === Edition.byteSize;
  }

  /**
   * Returns a readable version of {@link Edition} properties
   * and can be used to convert to JSON and/or logging
   */
  pretty() {
    return {
      key: 'Key.' + definedTypes.Key[this.key],
      parent: this.parent.toBase58(),
      edition: this.edition,
    };
  }
}

/**
 * @category Accounts
 * @category generated
 */
export const editionBeet = new beet.BeetStruct<Edition, EditionArgs>(
  [
    ['key', definedTypes.keyBeet],
    ['parent', beetSolana.publicKey],
    ['edition', beet.u64],
  ],
  Edition.fromArgs,
  'Edition',
);
