/**
 * This code was GENERATED using the solita package.
 * Please DO NOT EDIT THIS FILE, instead rerun solita to update it or write a wrapper to add functionality.
 *
 * See: https://github.com/metaplex-foundation/solita
 */

import * as splToken from '@solana/spl-token';
import * as definedTypes from '../types';
import * as beet from '@metaplex-foundation/beet';
import * as web3 from '@solana/web3.js';

/**
 * @category Instructions
 * @category DeprecatedMintPrintingTokens
 * @category generated
 */
export type DeprecatedMintPrintingTokensInstructionArgs = {
  mintPrintingTokensViaTokenArgs: definedTypes.MintPrintingTokensViaTokenArgs;
};
/**
 * @category Instructions
 * @category DeprecatedMintPrintingTokens
 * @category generated
 */
const DeprecatedMintPrintingTokensStruct = new beet.BeetArgsStruct<
  DeprecatedMintPrintingTokensInstructionArgs & {
    instructionDiscriminator: number;
  }
>(
  [
    ['instructionDiscriminator', beet.u8],
    ['mintPrintingTokensViaTokenArgs', definedTypes.mintPrintingTokensViaTokenArgsBeet],
  ],
  'DeprecatedMintPrintingTokensInstructionArgs',
);
/**
 * Accounts required by the _DeprecatedMintPrintingTokens_ instruction
 *
 * @property [_writable_] destination Destination account
 * @property [_writable_] printingMint Printing mint
 * @property [**signer**] updateAuthority Update authority
 * @property [] metadata Metadata key (pda of ['metadata', program id, mint id])
 * @property [] masterEdition Master Edition V1 key (pda of ['metadata', program id, mint id, 'edition'])
 * @category Instructions
 * @category DeprecatedMintPrintingTokens
 * @category generated
 */
export type DeprecatedMintPrintingTokensInstructionAccounts = {
  destination: web3.PublicKey;
  printingMint: web3.PublicKey;
  updateAuthority: web3.PublicKey;
  metadata: web3.PublicKey;
  masterEdition: web3.PublicKey;
};

const deprecatedMintPrintingTokensInstructionDiscriminator = 9;

/**
 * Creates a _DeprecatedMintPrintingTokens_ instruction.
 *
 * @param accounts that will be accessed while the instruction is processed
 * @param args to provide as instruction data to the program
 *
 * @category Instructions
 * @category DeprecatedMintPrintingTokens
 * @category generated
 */
export function createDeprecatedMintPrintingTokensInstruction(
  accounts: DeprecatedMintPrintingTokensInstructionAccounts,
  args: DeprecatedMintPrintingTokensInstructionArgs,
) {
  const { destination, printingMint, updateAuthority, metadata, masterEdition } = accounts;

  const [data] = DeprecatedMintPrintingTokensStruct.serialize({
    instructionDiscriminator: deprecatedMintPrintingTokensInstructionDiscriminator,
    ...args,
  });
  const keys: web3.AccountMeta[] = [
    {
      pubkey: destination,
      isWritable: true,
      isSigner: false,
    },
    {
      pubkey: printingMint,
      isWritable: true,
      isSigner: false,
    },
    {
      pubkey: updateAuthority,
      isWritable: false,
      isSigner: true,
    },
    {
      pubkey: metadata,
      isWritable: false,
      isSigner: false,
    },
    {
      pubkey: masterEdition,
      isWritable: false,
      isSigner: false,
    },
    {
      pubkey: splToken.TOKEN_PROGRAM_ID,
      isWritable: false,
      isSigner: false,
    },
    {
      pubkey: web3.SYSVAR_RENT_PUBKEY,
      isWritable: false,
      isSigner: false,
    },
  ];

  const ix = new web3.TransactionInstruction({
    programId: new web3.PublicKey('metaqbxxUerdq28cj1RbAWkYQm3ybzjb6a8bt518x1s'),
    keys,
    data,
  });
  return ix;
}
